/*
 *  RowSetDemo.java
 *
 *  $Id: RowSetDemo.java,v 1.1 2004/10/05 17:07:54 source Exp $
 *
 *  Sample JDBC program
 *
 *  (C)Copyright 1999 OpenLink Software.
 *  All Rights Reserved.
 *
 *  The copyright above and this notice must be preserved in all
 *  copies of this source code.  The copyright above does not
 *  evidence any actual or intended publication of this source code.
 *
 *  This is unpublished proprietary trade secret of OpenLink Software.
 *  This source code may not be copied, disclosed, distributed, demonstrated
 *  or licensed except as authorized by OpenLink Software.
 */

import java.awt.*;
import java.sql.*;

class RowSetDemo extends Frame implements Runnable 
{

  void NewThread_Action(Event event) 
  {
    RowSetDemo p = new RowSetDemo (urlList,isApplet);
    new Thread(p).start();
  }

  public void dataFieldKeyPressed(Event e) 
  {
    if(data !=null)
      for(int c=0; c < data.length; c++)
	for(int r=0; r < NUM_ROWS; r++) 
	  if(e.target==textColumnValue[c][r])
	  {
	    currentRow = r+1;
	    textStatus.setText("Current Row = "+currentRow);
	    return;
	  }
  }

  void buttonUpdate_Clicked(Event event) 
  {
    textStatus.setText("Updating record");
    for(int i=0; i< data.length; i++)
      data[i][currentRow-1]= textColumnValue[i][currentRow-1].getText ();
    try
    {
      if(result.update(currentRow))
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonAdd_Clicked(Event event) 
  {
    textStatus.setText("Adding record");
    for(int i=0; i< data.length; i++)
      data[i][currentRow-1]= textColumnValue[i][currentRow-1].getText ();
    try
    {
      if(result.add(currentRow))
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonGoTo_Clicked(Event event) 
  {
    int position = Integer.parseInt(textPos.getText());
    MoveToPos(position);
  }

  public void MoveToPos(int pos) 
  {
    textStatus.setText("Going to position "+pos);
    try
    {
      if(result.moveAbsolute(pos))
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void Absolute_Action(Event event) 
  {
    int position = Integer.parseInt(textPos.getText());
    MoveToPos(position);
  }

  void Exit_Action(Event event) 
  {
    hide();         // hide the Frame
    dispose();      // free the system resources
    synchronized (this)
    {
      numThreads--;
    }
    if (numThreads == 0)
      System.exit(0); // close the application
  }

  void CloseConnection_Action(Event event) 
  {
    textStatus.setText("Closing connection");
    try
    {
      if(conn!=null)
      {
	stmt.close();
	stmt = null;
	conn.close();
	conn = null;
      }
      textStatus.setText("Done.");
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
      conn=null;
    }
  }

  void OpenConnection_Action(Event event) 
  {
    (new DialogConnection(this, true,connectionURL,driverName, true)).show();
  }

  void buttonSetBM_Clicked(Event event) 
  {
    textStatus.setText("Going to the bookmark");
    try
    {
      if(result.setBookmark(bookmark))
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void PickConnection_Action(Event event) 
  {
    (new DialogConnectionList(this, true, urlList)).show();
  }

  void buttonGetBM_Clicked(Event event) 
  {
    textStatus.setText("Getting a bookmark");
    try
    {
      bookmark =  result.getBookmark();
      textStatus.setText("Done.");
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonUnlock_Clicked(Event event) 
  {
    textStatus.setText("Unlocking current row");
    try
    {
      if(result.unlock(currentRow))
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonLock_Clicked(Event event) 
  {
    textStatus.setText("Locking current row");
    try
    {
      if(result.lock(currentRow))
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonRefresh_Clicked(Event event) 
  {
    textStatus.setText("Refreshing the current row");
    try
    {
      if(result.refresh(currentRow))
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonDelete_Clicked(Event event) 
  {
    textStatus.setText("Deleting the current row");
    try
    {
      if(result.delete(currentRow))
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonLast_Clicked(Event event) 
  {
    textStatus.setText("Going to the last rowset");
    try
    {
      if(result.last())
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonFirst_Clicked(Event event) 
  {
    textStatus.setText("Going to the first rowset");
    try
    {
      if(result.first())
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonPrior_Clicked(Event event)
  {
    textStatus.setText("Going to the previous rowset");
    try
    {
      if(result.prior())
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonNext_Clicked(Event event)
  {
    textStatus.setText("Going to the next rowset");
    try
    {
      if(result.next())
	updateInfo();
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  void buttonQuery_Clicked(Event event) 
  {
    try
    {
      ExecuteQuery (textQuery.getText());
    }
    catch (Exception e)
    {
      textStatus.setText(e.toString());
    }
  }


  void ExecuteQuery (String query)
    throws Exception
  {
    int count;

    textStatus.setText("Connecting to :"+connectionURL);
    if(conn!=null)
    {
      stmt.close();
      stmt = null;
      conn.close();
      conn = null;
    }
    conn = DriverManager.getConnection (connectionURL);

    // Execute Query
    stmt = (openlink.sql.Statement)conn.createStatement ();
    stmt.setCursorType(stmt.SQL_CURSOR_KEYSET_DRIVEN);
    stmt.setConcurrency(stmt.SQL_CONCUR_VALUES);
    stmt.setRowSetSize(NUM_ROWS);
    stmt.useBookmarks(true);
    textStatus.setText("Executing query");
    result = (openlink.sql.RowSet)stmt.executeQuery (query);
    // Get Resultset information
    meta = result.getMetaData ();
    count = meta.getColumnCount ();
    labelColumnName = new Label[count];
    textColumnValue = new TextField[count][NUM_ROWS];
    data = new String[count][NUM_ROWS];
    Info.removeAll();
    GridLayout grid = new GridLayout(NUM_ROWS+1,count);
    Info.setLayout(grid);
    for (int c = 1; c <= count; c++)
    {
      labelColumnName[c-1]= new Label(meta.getColumnName (c),Label.CENTER);
      Info.add(labelColumnName[c-1]);
    }

    for(int row=0; row < NUM_ROWS; row++)
    {
      for (int c = 1; c <= count; c++)
      {
	textColumnValue[c-1][row] = new DataTextField(this);
	textColumnValue[c-1][row].setFont(new Font("Dialog", Font.PLAIN, 10));
	data[c-1][row] = new String();
	Info.add(textColumnValue[c-1][row]);
      }
    }
    for (int c = 1; c <= count; c++)
    {
      result.bindColumn(c,data[c-1]);
    }
    result.next();
    updateInfo();
    super.show();
  }

  void updateInfo()
  {
    textStatus.setText("Fetching result");
    try
    {
      for (int c = 1; c <= meta.getColumnCount (); c++)
      {
	for(int row=0; row < NUM_ROWS; row++)
	{
	  if(data[c-1][row] !=null)
	    textColumnValue[c-1][row].setText (data[c-1][row]);
	  else
	    textColumnValue[c-1][row].setText ("");
	}
      }
      textStatus.setText("Done.");
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
  }

  // Unfortunately, there appears to be a bug in the IE4 classloader when you try
  // to load and register the driver with Class.forName(driverName). 
  // The IE4 appears to retrieve the class file from the server, but the class's 
  // static initializer block is never executed. As the driver registers itself
  // in the static initializer block, this bug produces the "no suitable driver error"
  // if you try to register a driver using Class.forName(). 
  // Unfortunately, in an applet, you can't manipulate the system properties to 
  // put the driver in there. Thus it is necessary to create an instance of the 
  // driver here, and register it with the DriverManager manually.
  void loadDriver(String driverName)
  {
    try
    {
      Class clsDriver = Class.forName(driverName);
      java.sql.Driver driver = (java.sql.Driver)clsDriver.newInstance();
      DriverManager.registerDriver (driver);
    }
    catch(Exception e)
    {
      textStatus.setText(e.toString());
    }
    this.driverName = driverName;
  }

  public RowSetDemo(String URL[],boolean isApplet) 
  {
    if (URL != null && URL.length > 0)
      connectionURL = URL[0];
    jdkVersion  = (System.getProperty("java.version")).substring(0,3);
    this.isApplet = isApplet;
    menuBar1 = new java.awt.MenuBar();
    menuFile = new java.awt.Menu("File");
    menuFile.add("New Thread");
    menuFile.add("Set Connection URL...");
    if (isApplet)
      menuFile.add("Pick Connection URL...");
    menuFile.add("Close Current Connection");
    if (!isApplet)
      menuFile.add("Exit");
    menuBar1.add(menuFile);
    setMenuBar(menuBar1);
    setLayout(new BorderLayout(0,5));
    addNotify();
    resize(insets().left + insets().right + 746,insets().top + insets().bottom + 426);
    setBackground(new Color(12632256));
    panel3 = new java.awt.Panel();
    panel3.setLayout(new BorderLayout(5,10));
    panel3.reshape(insets().left + 0,insets().top + 0,746,21);
    panel3.setBackground(new Color(12632256));
    add("North", panel3);
    textQuery = new java.awt.TextField();
    textQuery.setText("SELECT \"CustomerID\", \"CompanyName\", \"ContactName\", \"Address\", \"City\" FROM \"Customers\"");
    textQuery.reshape(0,0,746,21);
    textQuery.setBackground(new Color(16777215));
    panel3.add("Center", textQuery);
    buttonQuery = new java.awt.Button("Query");
    buttonQuery.reshape(699,0,47,21);
    panel3.add("East", buttonQuery);
    Info = new java.awt.Panel();
    Info.setLayout(new GridLayout(1,1,0,0));
    Info.reshape(insets().left + 0,insets().top + 21,746,313);
    Info.setBackground(new Color(12632256));
    add("Center", Info);
    label1 = new java.awt.Label("",Label.RIGHT);
    label1.reshape(0,0,373,313);
    Info.add(label1);
    textField1 = new java.awt.TextField();
    textField1.reshape(373,0,373,313);
    textField1.setFont(new Font("Dialog", Font.PLAIN, 10));
    Info.add(textField1);
    panel4 = new java.awt.Panel();
    panel4.setLayout(new GridLayout(0,1,0,1));
    panel4.reshape(insets().left + 0,insets().top + 334,746,92);
    add("South", panel4);
    Toolbar = new java.awt.Panel();
    Toolbar.setLayout(new FlowLayout(FlowLayout.CENTER,10,1));
    Toolbar.reshape(0,0,746,30);
    Toolbar.setBackground(new Color(12632256));
    panel4.add(Toolbar);
    panel1 = new java.awt.Panel();
    panel1.setLayout(new GridLayout(1,0,2,0));
    panel1.reshape(129,5,178,21);
    Toolbar.add(panel1);
    buttonFirst = new java.awt.Button("  First  ");
    buttonFirst.reshape(0,0,43,21);
    buttonFirst.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel1.add(buttonFirst);
    buttonPrior = new java.awt.Button("Prior");
    buttonPrior.reshape(45,0,43,21);
    buttonPrior.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel1.add(buttonPrior);
    buttonNext = new java.awt.Button("Next");
    buttonNext.reshape(90,0,43,21);
    buttonNext.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel1.add(buttonNext);
    buttonLast = new java.awt.Button("Last");
    buttonLast.reshape(135,0,43,21);
    buttonLast.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel1.add(buttonLast);
    panel2 = new java.awt.Panel();
    panel2.setLayout(new GridLayout(1,0,2,0));
    panel2.reshape(312,5,304,21);
    Toolbar.add(panel2);
    buttonDelete = new java.awt.Button("Delete");
    buttonDelete.reshape(0,0,49,21);
    buttonDelete.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel2.add(buttonDelete);
    buttonRefresh = new java.awt.Button("Refresh");
    buttonRefresh.reshape(51,0,49,21);
    buttonRefresh.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel2.add(buttonRefresh);
    buttonLock = new java.awt.Button("Lock");
    buttonLock.reshape(102,0,49,21);
    buttonLock.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel2.add(buttonLock);
    buttonUnlock = new java.awt.Button("Unlock");
    buttonUnlock.reshape(153,0,49,21);
    buttonUnlock.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel2.add(buttonUnlock);
    buttonAdd = new java.awt.Button("Add");
    buttonAdd.reshape(204,0,49,21);
    buttonAdd.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel2.add(buttonAdd);
    buttonUpdate = new java.awt.Button("Update");
    buttonUpdate.reshape(255,0,49,21);
    buttonUpdate.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel2.add(buttonUpdate);
    panel5 = new java.awt.Panel();
    panel5.setLayout(new FlowLayout(FlowLayout.CENTER,2,0));
    panel5.reshape(0,31,746,30);
    panel4.add(panel5);
    buttonGetBM = new java.awt.Button("Get Bookmark");
    buttonGetBM.reshape(248,5,82,21);
    buttonGetBM.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel5.add(buttonGetBM);
    buttonSetBM = new java.awt.Button("Set Bookmark");
    buttonSetBM.reshape(335,5,81,21);
    buttonSetBM.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel5.add(buttonSetBM);
    buttonGoTo = new java.awt.Button("Go To");
    buttonGoTo.reshape(421,5,44,21);
    buttonGoTo.setFont(new Font("Dialog", Font.PLAIN, 12));
    panel5.add(buttonGoTo);
    textPos = new java.awt.TextField();
    textPos.setText("1");
    textPos.reshape(470,5,27,21);
    panel5.add(textPos);
    textStatus = new java.awt.TextField();
    textStatus.setEditable(false);
    textStatus.reshape(0,62,746,30);
    textStatus.setFont(new Font("Dialog", Font.PLAIN, 10));
    panel4.add(textStatus);
    setTitle("JDBC Scrollable Cursor RowSet Demo");
    Info.remove(label1);
    Info.remove(textField1);
    urlList = URL;
    /*BEGIN_WEBJDBC
    loadDriver("openlink.jdbc.Driver");
    END_WEBJDBC*/
    ////BEGIN_NOT_WEBJDBC
    if (jdkVersion.equalsIgnoreCase("1.0") || 
        jdkVersion.equalsIgnoreCase("1.1"))
      loadDriver("openlink.jdbc.Driver");
    else if (jdkVersion.equalsIgnoreCase("1.2") || 
        jdkVersion.equalsIgnoreCase("1.3"))
      loadDriver("openlink.jdbc2.Driver");
    else
      loadDriver("openlink.jdbc3.Driver");
    ////END_NOT_WEBJDBC
  }

  public void show() 
  {
    move(20*myThreadNum, 20*myThreadNum);
    super.show();
  }

  public String MakeConnectURL(String inurl, String inkey, String invalue)
  {
    int inkeypos, endpos;

	inkeypos = inurl.indexOf(inkey+"=",0);
	if (inkeypos <0)
	{
		return inurl + "/" + inkey + "=" + invalue;
	}
	endpos = inurl.indexOf("/",inkeypos);
	if (endpos <0)
	{
		return inurl.substring(0,inkeypos) + inkey + "=" + invalue;
	}

	return inurl.substring(0,inkeypos) + inkey + "=" + invalue + inurl.substring(endpos);
  }

  public boolean handleEvent(Event event) 
  {
    if (event.id == -1) 
    {
      connectionURL = (String)(event.arg);
      textStatus.setText("Connection URL is  :"+connectionURL);
      return true;
    }
    else if (event.id == -2) 
    {
      driverName = (String)(event.arg);
      textStatus.setText("Driver name is :"+driverName);
      loadDriver(driverName);
      return true;
    }
    else if (event.id == -5) 
    {
      DbName = (String)(event.arg);
      connectionURL = MakeConnectURL(connectionURL, "DATABASE", DbName);
      textStatus.setText("Connection URL is  :"+connectionURL);
      return true;
    }
    else if (event.id == -3) 
    {
      userName = (String)(event.arg);
      connectionURL = MakeConnectURL(connectionURL, "UID", userName);
      textStatus.setText("Connection URL is  :"+connectionURL);
      return true;
    }
    else if (event.id == -4) 
    {
      password = (String)(event.arg);
      connectionURL = MakeConnectURL(connectionURL, "PWD", password);
      textStatus.setText("Connection URL is  :"+connectionURL);
      return true;
    }
    if (event.id == Event.WINDOW_DESTROY) 
    {
      try
      {
	if(conn!=null)
	{
	  stmt.close();
	  stmt = null;
	  conn.close();
	  conn = null;
	}
      }
      catch(Exception e)
      {
      }
      if (isApplet)
      {
	hide();         // hide the Frame
	dispose();      // free the system resources
      }
      else
      {
	Exit_Action(event);
      }
      return true;
    }
    if (event.target == buttonQuery && event.id == Event.ACTION_EVENT) 
    {
      buttonQuery_Clicked(event);
      return true;
    }
    if (event.target == buttonNext && event.id == Event.ACTION_EVENT) 
    {
      buttonNext_Clicked(event);
      return true;
    }
    if (event.target == buttonPrior && event.id == Event.ACTION_EVENT) 
    {
      buttonPrior_Clicked(event);
      return true;
    }
    if (event.target == buttonFirst && event.id == Event.ACTION_EVENT) 
    {
      buttonFirst_Clicked(event);
      return true;
    }
    if (event.target == buttonLast && event.id == Event.ACTION_EVENT) 
    {
      buttonLast_Clicked(event);
      return true;
    }
    if (event.target == buttonDelete && event.id == Event.ACTION_EVENT) 
    {
      buttonDelete_Clicked(event);
      return true;
    }
    if (event.target == buttonRefresh && event.id == Event.ACTION_EVENT) 
    {
      buttonRefresh_Clicked(event);
      return true;
    }
    if (event.target == buttonLock && event.id == Event.ACTION_EVENT) 
    {
      buttonLock_Clicked(event);
      return true;
    }
    if (event.target == buttonUnlock && event.id == Event.ACTION_EVENT) 
    {
      buttonUnlock_Clicked(event);
      return true;
    }
    if (event.target == buttonGetBM && event.id == Event.ACTION_EVENT) 
    {
      buttonGetBM_Clicked(event);
      return true;
    }
    if (event.target == buttonSetBM && event.id == Event.ACTION_EVENT) 
    {
      buttonSetBM_Clicked(event);
      return true;
    }
    if (event.target == buttonGoTo && event.id == Event.ACTION_EVENT) 
    {
      buttonGoTo_Clicked(event);
      return true;
    }
    if (event.target == buttonAdd && event.id == Event.ACTION_EVENT) 
    {
      buttonAdd_Clicked(event);
      return true;
    }
    if (event.target == buttonUnlock && event.id == Event.ACTION_EVENT) 
    {
      buttonUnlock_Clicked(event);
      return true;
    }
    if (event.target == buttonAdd && event.id == Event.ACTION_EVENT) 
    {
      buttonAdd_Clicked(event);
      return true;
    }
    if (event.target == buttonUpdate && event.id == Event.ACTION_EVENT) 
    {
      buttonUpdate_Clicked(event);
      return true;
    }
    if (event.id == Event.KEY_PRESS || event.id == Event.KEY_ACTION) 
    {
      dataFieldKeyPressed(event);
    }
    return super.handleEvent(event);
  }

  public boolean action(Event event, Object arg) 
  {
    if (arg.toString().equalsIgnoreCase("Set Connection URL...")) 
    {
      OpenConnection_Action(event);
      return true;
    }
    if (arg.toString().equalsIgnoreCase("Pick Connection URL...")) 
    {
      PickConnection_Action(event);
      return true;
    }
    if (arg.toString().equalsIgnoreCase("Exit")) 
    {
      Exit_Action(event);
      return true;
    }
    if (arg.toString().equalsIgnoreCase("Close Current Connection")) 
    {
      CloseConnection_Action(event);
      return true;
    }
    if (arg.toString().equalsIgnoreCase("New Thread")) 
    {
      NewThread_Action(event);
      return true;
    }
    return super.action(event, arg);
  }

  static public void main(String args[]) 
  {
    String URL=null;
    if(args.length>0)
      URL = args[0];
    RowSetDemo rsd = new RowSetDemo(args,false);
    rsd.show();
  }


  public void run() 
  {
    synchronized (this)
    {
      numThreads++;
      numThreadsInvoked++;
      myThreadNum = numThreadsInvoked;
    }
    show();
  }

  java.awt.Panel panel3;
  java.awt.TextField textQuery;
  java.awt.Button buttonQuery;
  java.awt.Panel Info;
  java.awt.Label label1;
  java.awt.TextField textField1;
  java.awt.Panel panel4;
  java.awt.Panel Toolbar;
  java.awt.Panel panel1;
  java.awt.Button buttonFirst;
  java.awt.Button buttonPrior;
  java.awt.Button buttonNext;
  java.awt.Button buttonLast;
  java.awt.Panel panel2;
  java.awt.Button buttonDelete;
  java.awt.Button buttonRefresh;
  java.awt.Button buttonLock;
  java.awt.Button buttonUnlock;
  java.awt.Button buttonAdd;
  java.awt.Button buttonUpdate;
  java.awt.Panel panel5;
  java.awt.Button buttonGetBM;
  java.awt.Button buttonSetBM;
  java.awt.Button buttonGoTo;
  java.awt.TextField textPos;
  java.awt.TextField textStatus;
  java.awt.MenuBar menuBar1;
  java.awt.Menu menuFile;
  java.sql.ResultSetMetaData meta=null;
  openlink.sql.Statement stmt=null;
  openlink.sql.RowSet result=null;
  java.sql.Connection conn=null;
  java.awt.Label[] labelColumnName;
  java.awt.TextField[][] textColumnValue;
  int bookmark=0;
  public String connectionURL="jdbc:openlink://localhost/SVT=SQLServer 7/Database=pubs/UID=sa/PWD=/";
  String[][] data;
  int currentRow=1;
  final int NUM_ROWS=5;
  static int numThreads = 1;
  static int numThreadsInvoked = 1;
  int myThreadNum;
  String[] urlList;
  String userName, password, driverName, DbName;
  boolean isApplet=false;
  String jdkVersion;
}

